<?php $scrpt_vrsn_dt  = 'AQ_wh45_block.php|01|2020-12-31|';  # PHP8 + clean | release 2012_lts
# 
# -----------------     SETTINGS for this script
$co2_lvls       = array (0, 400, 1000, 1500, 2000, 5000);
#       level = 1  # 0 to 400        Excellent                      Green
#       level = 2  # 400 to 1000     Fine, unbedenklich             Green
#       level = 3  # 1000 to 1500    Moderate, Lueften              Yellow
#       level = 4  # 1500 to 2000    Poor, Lueften!                 Red
#       level = 5  # 2000 to 5000    Very Poor, inakzeptabel        Purple
#       level = 6  # from 5000       Severe                         Maroon
#
$first_description      = 'Inside';
#
#-----------------------------------------------
#         PWS-Dashboard - Updates and support by 
#     Wim van der Kuil https://pwsdashboard.com/
#-----------------------------------------------
#       display source of script if requested so
#-----------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
   $filenameReal = __FILE__;  
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header('Content-type: text/plain; charset=UTF-8');
   header('Accept-Ranges: bytes');
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;}
elseif (!isset ($_REQUEST['test'])) 
     {  ini_set('display_errors', 0);   error_reporting(0);}
# -------------------save list of loaded scrips;
if (!isset ($stck_lst) ) {$stck_lst = '';}
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') version =>'.$scrpt_vrsn_dt.PHP_EOL;       
#
# ------------check if script is already running
$string = str_replace('.php','',basename(__FILE__));
if (isset ($$string) ) {echo 'This info is already displayed'; return;}
$$string = $string;
#
# -------------load weatherdata and all settings 
$scrpt          = 'PWS_livedata.php'; 
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') include_once =>'.$scrpt.PHP_EOL;
include_once $scrpt; 
#
#-----------------------------------------------
#     check if data is usable
#-----------------------------------------------
$dataFALSE              = '';
if (! array_key_exists ('pm25_co2', $weather) ) 
     {  $dataFALSE = __LINE__.': No WH45 CO2 sensor found'; }
if ($dataFALSE<> '')
     {  echo 'Problem '.$dataFALSE.'<br />Check settings and data'; return;}
#
#-----------------------------------------------
#      general functions / tables for AQ scripts
#-----------------------------------------------
#$co2_color = array ('orange', 'green', '#00e400', 'yellow', 'red', 'purple', 'maroon');
$co2_color = array ('#ff7e00', '#00e400', '#00e400', '#ffff00', '#ff0000', '#8f3f97', '#7e0023');
$co2_icon  = array ('aq_orange.svg', 'aq_green.svg', 'aq_green.svg', 'aq_yellow.svg', 'aq_red.svg', 'aq_purple.svg', 'aq_maroon.svg');
$co2_text  = array ('Unknown', 'Excellent', 'Fine', 'Moderate', 'Poor', 'Very Poor', 'Severe');

$scrpt          = 'AQ_shared.php';  
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') include  =>'.$scrpt.PHP_EOL; 
include_once $scrpt; 
#
#-----------------------------------------------
#                         gather data to be used 
#-----------------------------------------------
# 
$aq_unix        = $weather['datetime'];
$aq_time        = set_my_time($aq_unix,true);
$aq_co2         = '#<br />'.lang($first_description); 

# PM25
$aq_co2_pm25    = number_format($weather['pm25_co2'],1); 
$aq_co2_pm25Avg = false;  
if (array_key_exists ('pm25_co2_24avg', $weather) ) 
     {  $aq_co2_pm25Avg  = number_format($weather['pm25_co2_24avg'],1);
        $aq_avg         = true;}
else {  $aq_avg         = false;}
#
$aq_pm25_aqi    = number_format(pm25_to_aqi($aq_co2_pm25),1 );
if ($aq_avg == true)
     {  $aq_pm25_aqiAvg = number_format(pm25_to_aqi($aq_co2_pm25Avg),1 );}
#
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') $aq_co2_pm25='.$aq_co2_pm25.' $aq_pm25_aqi='.$aq_pm25_aqi.PHP_EOL;    
if ($aq_avg) 
     {  $stck_lst      .= basename(__FILE__).' ('.__LINE__.') $aq_co2_pm25Avg='.$aq_co2_pm25Avg.' $aq_pm25_aqiAvg='.$aq_pm25_aqiAvg.PHP_EOL; }   

# PM10
$aq_co2_pm10    = number_format($weather['pm10_co2'],1); 
$aq_co2_pm10Avg = false;  
if (array_key_exists ('pm10_co2_24avg', $weather) ) 
     {  $aq_co2_pm10Avg  = number_format($weather['pm10_co2_24avg'],1);
        $aq_avg         = true;}
else {  $aq_avg         = false;}
#
$aq_pm10_aqi    = number_format(pm10_to_aqi($aq_co2_pm10),1 );
if ($aq_avg == true)
     {  $aq_pm10_aqiAvg = number_format(pm10_to_aqi($aq_co2_pm10Avg),1 );}
#
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') $aq_co2_pm10='.$aq_co2_pm10.' $aq_pm10_aqi='.$aq_pm10_aqi.PHP_EOL;    
if ($aq_avg) 
     {  $stck_lst      .= basename(__FILE__).' ('.__LINE__.') $aq_co2_pm10Avg='.$aq_co2_pm10Avg.' $aq_pm10_aqiAvg='.$aq_pm10_aqiAvg.PHP_EOL; }   

# CO2
#$aq_co2    = number_format($weather['co2'],1);
$aq_co2    = $weather['co2'];
 
$aq_co2Avg = false;  
if (array_key_exists ('co2_24avg', $weather) ) 
     {  $aq_co2Avg  = number_format($weather['co2_24avg'],1);
        $aq_avg         = true;}
else {  $aq_avg         = false;}

# temp/hum
$co2_level = CO2level($aq_co2);
$tmp_l  = '&deg;'.$weather['temp_units'];
$tf_co2 = number_format($weather['tf_co2'],1);
$humi_co2 = number_format($weather['humi_co2'],0);

#
$now            = time();
$diff           = $now - $aq_unix; 
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') $weather["datetime"]='.$weather['datetime'].' $now='.$now.' $diff='.$diff.' '.PHP_EOL; 
#
# ------------------- define colors a.s.o. for an AQI
$arr    = aq_set_clrs ($aq_pm25_aqi); 
# -------------------------------- assemble html
$head_txt = '<br />';
#$head_txt = 
#'<table style="width: 100%;">
#  <tr style="text-align: center; font-size: 10px;">
#    <td style="width: 30%; margin: 0px 5px;"><b>PM2.5</b>
#    </td>
#    <td style="width: 40%;">&nbsp;</td>
#    <td style="width: 30%;"><b>PM10</b></td>
#  </tr>
#</table>';

$left_txt = 
'<div class="PWS_left" style="height: 110px; ">
    <div class="PWS_div_left" style="height: 110px; margin: 0px 5px; font-size: 10px; ">
        <span  class="normal" ><b>PM2.5</b>:<br /><b>'.lang('Current').'<br />'.$aq_co2_pm25.'</b><small> ug/m3</small><br />AQI: <b>'.$aq_pm25_aqi.'</b><br /><b>'.lang('24h Avg').'<br />'.$aq_pm25_aqiAvg.'</b> AQI<br /><b>'.$aq_co2_pm25Avg.'</b><small> ug/m3</small><br /><br /><b>'.$tf_co2." ".$tmp_l.'</b>
        </span>
    </div>
</div>'.PHP_EOL;
#
$middle_text = 
'<div class="PWS_middle" style="height: 100px;"><!-- large icon -->
    CO2:&nbsp;<b class=""  style="font-size: 20px; line-height: 1.0;">'.$aq_co2.' </b><small> ppm</small><br />
    <div class="PWS_round" 
        style = "margin: 0 auto; margin-top: 5px;
                 width: 72px; 
                 height: 72px; 
                 background-color: '.$co2_color[$co2_level].'; 
                 border: 0px solid silver;">
        <img src="./img/'.$co2_icon[$co2_level].'" width="72" height="72" alt="Air quality: '.$co2_text[$co2_level] .' " title="Air quality: ' .$co2_text[$co2_level].' " />
    </div>
</div>'.PHP_EOL;
#
$right_text     = 
'<div class="PWS_right" style="height: 110px;">
    <div class="PWS_div_right" style="height: 110px;  margin: 0px 5px; font-size: 10px; ">
        <span  class="normal" ><b>PM10</b>:<br />'.PHP_EOL;
$right_text    .= '        <b>'.lang('Current') .'<br />'                                     .$aq_co2_pm10   .'</b><small> ug/m3</small><br />AQI: <b>'.$aq_pm10_aqi.'</b><br />'.PHP_EOL;  
if ($aq_avg == true)
     {  $right_text    .= '        <b>'.lang('24h Avg') .'<br />' .$aq_pm10_aqiAvg.'</b> AQI<br /><b>'.$aq_co2_pm10Avg.'</b><small> ug/m3</small><br /><br /><b>'.$humi_co2."</b> %".PHP_EOL;}
$right_text    .= '        </span>
    </div>
</div>'.PHP_EOL;

$bottom_text = '<div style="clear: both; width: 100%; font-size: 16px; padding-top: 5px;">'.lang($co2_text[$co2_level]).'</div>
<!-- eo weatheritem 2 -->'.PHP_EOL;

if (isset ($PWS_popup))   {  return; }  // are we in a popup 
#
# ------------            date time of last data
echo '<div class="PWS_ol_time">'.$online_txt_ld.'</div>'.PHP_EOL;
#echo '<br />'.$left_txt.$middle_text.$right_text.$bottom_text;
echo $head_txt.$left_txt.$middle_text.$right_text.$bottom_text;
#
#  print needed debug messages
if (isset ($_REQUEST['test']) ) { echo '<!-- '.PHP_EOL.$stck_lst.'-->'.PHP_EOL; $stck_lst='';}

#
function CO2level($co2) {
        global $co2_lvls;
        $co2    = (int) $co2;
        if ($co2 == 0)                {  return 0; }
        if ($co2 <= $co2_lvls[1])     {  return 1; }  # level = 1  # 0 to 400        Excellent                      Green
        elseif ($co2 <= $co2_lvls[2]) {  return 2; }  # level = 2  # 400 to 1000     Fine, unbedenklich             Green
        elseif ($co2 <= $co2_lvls[3]) {  return 3; }  # level = 3  # 1000 to 1500    Moderate, Lueften              Yellow
        elseif ($co2 <= $co2_lvls[4]) {  return 4; }  # level = 4  # 1500 to 2000    Poor, Lueften!                 Red
        elseif ($co2 <= $co2_lvls[5]) {  return 5; }  # level = 5  # 2000 to 5000    Very Poor, inakzeptabel        Purple
        else                          {  return 6; }    # level = 6  # from 5000       Severe                         Maroon
}

