<?php $scrpt_vrsn_dt  = 'AQ_wh45_small.php|01|2021-12-31|';  # release 2012_lts
#-----------------------------------------------
#         PWS-Dashboard - Updates and support by 
#     Wim van der Kuil https://pwsdashboard.com/
#-----------------------------------------------
#       display source of script if requested so
#-----------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
   $filenameReal = __FILE__;  
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header('Content-type: text/plain; charset=UTF-8');
   header('Accept-Ranges: bytes');
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;}
elseif (!isset ($_REQUEST['test'])) 
     {  ini_set('display_errors', 0);   error_reporting(0);}
# -------------------save list of loaded scrips;
if (!isset ($stck_lst) ) {$stck_lst = '';}
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') version =>'.$scrpt_vrsn_dt.PHP_EOL;       
#
# ------------check if script is already running
$string = str_replace('.php','',basename(__FILE__));
if (isset ($$string) ) {echo 'This info is already displayed'; return;}
$$string = $string;
#
# -------------load weatherdata and all settings 
$scrpt          = 'PWS_livedata.php'; 
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') include_once =>'.$scrpt.PHP_EOL;
include_once $scrpt; 
#----------------------------------- test values
#$weather['co2'] = 5100;
#unset ($weather['co2']);
#
#----------------------- check if data is usable
$dataFALSE              = '';    
if (! array_key_exists ('co2', $weather) ) 
     {  $dataFALSE = 'Problem #'.__LINE__.': No WH45 CO2 sensor found'; } 
if ($dataFALSE<> '')
     {  echo '<small style="color: red;">'.$dataFALSE.'<br />Check settings and data</small>'; return;}
#
#--------------------------------- tables for AQ 
$co2_color      = array ('#ff7e00', '#00e400', '#00e400', '#ffff00', '#ff0000', '#8f3f97', '#7e0023');
$co2_icon       = array ('aq_orange.svg', 'aq_green.svg', 'aq_green.svg', 'aq_yellow.svg', 'aq_red.svg', 'aq_purple.svg', 'aq_maroon.svg');
$co2_text       = array ('Unknown', 'Excellent', 'Fine', 'Moderate', 'Poor', 'Very Poor', 'Severe');
$co2_func       = array ('unknown','Excellent air','Fine air','Moderate air, ventilation recommended','Poor air, ventilation necessary','Very poor air, unacceptable','Severe air, leave the room');
$co2_lvls       = array (0, 400, 1000, 1500, 2000, 5000);
#       level = 1  # 0 to 400        Excellent                      Green
#       level = 2  # 400 to 1000     Fine, unbedenklich             Green
#       level = 3  # 1000 to 1500    Moderate, Lueften              Yellow
#       level = 4  # 1500 to 2000    Poor, Lueften!                 Red
#       level = 5  # 2000 to 5000    Very Poor, inakzeptabel        Purple
#       level = 6  # from 5000       Severe                         Maroon
#
#-----------------------  gather data to be used 
# 
$aq_co2         = (int) $weather['co2'];
for ($n = 0; $n < count($co2_lvls); $n++)
     {  if ($co2_lvls[$n] <= $aq_co2)
             {  $co2_level = $n + 1;
                continue;}
        break;}
#
# -------------------------------- assemble html
$my_color       = $co2_color[$co2_level];
$my_text        = lang($co2_func [$co2_level]);
$img_w          = '55';
echo 
'<div class="PWS_round" 
        style = "margin: 2px;
                 width: '.$img_w.'px; 
                 height: '.$img_w.'px; 
                 background-color: '.$my_color.'; 
                 border: 0px solid silver;
                 float: left;">
        <img src="./img/'.$co2_icon[$co2_level].'" 
                width="'.$img_w.'" height="'.$img_w.'" 
                alt="Air quality: '.$my_text .' " 
                title="Air quality: ' .$my_text.' " />
</div>'.PHP_EOL;
#
echo
'<div style="font-size:14px; padding-top: 4px; vertical-align: middle;">
        CO2:&nbsp;<b class=""  style="font-size: 20px; line-height: 1.0;">'.$aq_co2.'</b><small> ppm</small><br />'
        .$my_text
        .'</b>
</div>'.PHP_EOL;
#  print needed debug messages
if (isset ($_REQUEST['test']) ) { echo '<!-- '.PHP_EOL.$stck_lst.'-->'.PHP_EOL; $stck_lst='';}


